找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1220|回复: 1

通过代码实现启动表格对象的breaks

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2021-1-31 01:02:29 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
Enabling Table breaks through code

问题:

I would like to enable table breaks just the way AutoCAD does when clicking on the small triangular grip. Can you provide a sample code for this ?

解答:

There are properties and methods that help in configuring the table breaks. The sample code provided here may require changes to suit your needs. Here is a sample code :
  1.             Document activeDoc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

  2.             Database db = activeDoc.Database;

  3.             Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;



  4.             PromptEntityOptions peo = new PromptEntityOptions("Select a table : ");

  5.             peo.SetRejectMessage("Please select the table to modify");

  6.             peo.AddAllowedClass(typeof(Table), true);

  7.             PromptEntityResult per = ed.GetEntity(peo);

  8.             if (per.Status != PromptStatus.OK)

  9.                 return;



  10.             ObjectId oid = per.ObjectId;



  11.             try

  12.             {

  13.                 using (Transaction tr = db.TransactionManager.StartTransaction())

  14.                 {

  15.                     Table table = tr.GetObject(oid, OpenMode.ForWrite) as Table;



  16.                     table.BreakOptions = TableBreakOptions.EnableBreaking & TableBreakOptions.RepeatTopLabels;

  17.                     table.BreakFlowDirection = TableBreakFlowDirection.Right;

  18.                     table.BreakEnabled = true;

  19.                     table.FlowDirection = FlowDirection.LeftToRight;

  20.                     table.SetBreakHeight(0, table.Height / 3.0);

  21.                     table.SetBreakOffset(0, Vector3d.XAxis * 2.0);

  22.                     table.SetBreakSpacing(25);



  23.                     table.RecomputeTableBlock(true);



  24.                     tr.Commit();

  25.                 }

  26.             }

  27.             catch (System.Exception ex)

  28.             {

  29.                 ed.WriteMessage(ex.Message);

  30.             }


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 2230个

财富等级: 金玉满堂

发表于 2021-1-31 10:27:44 | 显示全部楼层
做个对论坛有益的人。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-4-26 01:38 , Processed in 0.294814 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表